unit uInicioYFinal;
{ Registro de clases centralizado }
interface

uses
  Classes,
  uCosa,
  uCosaConNombre,
  uActores,
  uforzamientos,
  uActorNodal,
  uGlobs,
  uFuncionesReales,
  uSalasDeJuego,
{$IFDEF MONITORES}
  uEventosOptSim,
  uManejadoresDeMonitores,
  uReferenciaMonitor,
  uReferenciaMonitorConsola,
  uReferenciaMonArchivo,
  uReferenciaMonHistograma,
  uReferenciaMonSimRes,
  {$IFDEF MODOGRAFICO}
  uReferenciaMonitorGraficoSimple,
  {$ENDIF}
  {$ENDIF}
{$IFDEF INFOTIPOS}
  uInfoCosa,
{$ENDIF}
  uGeneradores,
  uGTer_Basico,
  ugter_basico_trep,
  ugter_basico_PyCVariable,
{$IFDEF MIPSimplex}
  uGTer_OnOffPorPoste,
  {$IFDEF COMBUSTIBLES}
  uGTer_OnOffPorPosteV2,
  ugter_onoffporpasoV2,
  ugter_arranqueparadaV2,
  ugter_combinadoV2,
  {$ENDIF}
{$ENDIF}
  ugter_combinado,
  uGTer,
  uGTer_OnOffPorPaso,
  ugter_onoffporpaso_conrestricciones,
  uGTer_ArranqueParada,
  usolartermico,
  usolarPV,
  ubiomasaembalsable,
  uParqueEolico,
  uParqueEolico_vxy,
  uDemandas,
  uDemandas01, uDemandaDetallada, uDemandaAnioBaseEIndices,
  uArcos, uNodos,
  uHidroConEmbalse,
  uHidroConEmbalseBinacional,
  uHidroDePasada,
  uHidroConBombeo,
  uComercioInternacional,
  uMercadoSpot,
  uMercadoSpot_postizado,
  uMercadoSpotConDetalleHorarioSemanal,
  ucontratomodalidaddevolucion,
  ubancodebaterias01,
  uarcoconsalidaprogramable,
  uUsoGestionable_postizado,
  uFuentesAleatorias,
  uFuenteWeibull,
  uFuenteGaussiana,
  uFuenteConstante,
  uFuenteUniforme,
  uFuenteSintetizador,

  uFuenteCombinacion,
  uFuenteProducto,
  uFuenteSelector,
  ufuentemaxmin,

  ufuentetiempo,
  ufuentesinusoide,

  ufichasLPD,
  upronostico,
  ufichasdeterminismos_obsoleta, // obsoleta, solo para leer salas viejas
  uEstados,

{$IFDEF REGAS_UTE}
  uSuministroCombustible,
  uGNLSumIntermedio,
  uGNLSuministroMultiCliente,
  uGNLSuministroCombustibleSimple,
  uGNLSumConector,
  uGNLSumComb_TakeOrPay_Spot,
  uGNLProveedor,
  uGNLPlanta,
  uGNLListaContratoSuministro,
  uGNLGasoducto,
  uGNLContratoSuministro,
  uSuministroCombustible_TakeOrPay,
  ugter_ConectableASuministro,
{$ENDIF}

  ulistaplantillassr3,
  ufuenteselector_horario,

{PROYECTO ANII - AGENDA GNL}
  uCombustible,
  unodocombustible,
  uActorNodalCombustible,
  uArcoCombustible,
  uDemandaCombustible,
  uDemandaCombustibleAnioBaseEIndices,
  ugsimple_bicombustible,
  ugsimple_monocombustible,
  uTSumComb,
  uRegasificadora,
  uAgendaGNL,

{$IFDEF MISION_IMPOSIBLE}
  uVirtualTablesDefs, uRegistroDeEditores,
{$ENDIF}

  uescenarios;

procedure AlInicio;
procedure AlFinal;

implementation

var
  cnt_llamadas: integer;



procedure Call_Inicio_o_Final( flg_Inicio: boolean );
begin
  if flg_Inicio then uCosa.AlInicio else uCosa.AlFinal; // tiene que ser la primera
  if flg_Inicio then uCosaConNombre.AlInicio else uCosaConNombre.AlFinal; //tiene que ser la segunda
  if flg_Inicio then uGlobs.AlInicio else uGlobs.AlFinal;
  if flg_Inicio then uFuncionesReales.AlInicio else uFuncionesReales.AlFinal;
  if flg_Inicio then uSalasDeJuego.AlInicio else uSalasDeJuego.AlFinal;
{$IFDEF INFOTIPOS}
  if flg_Inicio then uInfoCosa.AlInicio  else uInfoCosa.AlFinal;
{$ENDIF}


{$IFDEF MONITORES}
  if flg_Inicio then uEventosOptSim.alInicio else uEventosOptSim.AlFinal;
  if flg_Inicio then uManejadoresDeMonitores.AlInicio else uManejadoresDeMonitores.AlFinal;
  if flg_Inicio then uReferenciaMonitor.AlInicio else uReferenciaMonitor.AlFinal;
  if flg_Inicio then uReferenciaMonitorConsola.AlInicio else uReferenciaMonitorConsola.AlFinal;
  if flg_Inicio then uReferenciaMonArchivo.AlInicio else uReferenciaMonArchivo.AlFinal;
  if flg_Inicio then uReferenciaMonHistograma.AlInicio else uReferenciaMonHistograma.AlFinal;
  if flg_Inicio then uReferenciaMonSimRes.AlInicio else uReferenciaMonSimRes.AlFinal;
{$IFDEF MODOGRAFICO}
  if flg_Inicio then uReferenciaMonitorGraficoSimple.AlInicio else uReferenciaMonitorGraficoSimple.AlFinal;
{$ENDIF}
{$ENDIF}
  if flg_Inicio then uforzamientos.AlInicio else uforzamientos.AlFinal;

  // Actores ============================
  if flg_Inicio then uActores.AlInicio else uActores.AlFinal;
  if flg_Inicio then uActorNodal.AlInicio else uActorNodal.AlFinal;
  if flg_Inicio then uNodos.AlInicio else uNodos.AlFinal;
  if flg_Inicio then uArcos.AlInicio else uArcos.AlFinal;
  if flg_Inicio then uArcoConSalidaProgramable.AlInicio else uArcoConSalidaProgramable.AlFinal;
  if flg_Inicio then uDemandas01.AlInicio else uDemandas01.AlFinal;
  if flg_Inicio then uDemandas.AlInicio else uDemandas.AlFinal;
  if flg_Inicio then uDemandaDetallada.AlInicio else uDemandaDetallada.AlFinal;
  if flg_Inicio then uDemandaAnioBaseEIndices.AlInicio else uDemandaAnioBaseEIndices.AlFinal;
  if flg_Inicio then uGeneradores.AlInicio else uGeneradores.AlFinal;
  if flg_Inicio then uGTer_Basico.AlInicio else uGTer_Basico.AlFinal;
  if flg_Inicio then ugter_basico_trep.AlInicio else ugter_basico_trep.AlFinal;
  if flg_Inicio then ugter_basico_PyCVariable.AlInicio else ugter_basico_PyCVariable.AlFinal;

  {$IFDEF MIPSimplex}
  if flg_Inicio then uGTer_OnOffPorPoste.AlInicio else uGTer_OnOffPorPoste.AlFinal;
  if flg_Inicio then ugter_combinado.AlInicio else ugter_combinado.AlFinal;
  if flg_Inicio then uGTer_OnOffPorPaso.AlInicio else uGTer_OnOffPorPaso.AlFinal;
  if flg_Inicio then ugter_onoffporpaso_conrestricciones.AlInicio else ugter_onoffporpaso_conrestricciones.AlFinal;
  if flg_Inicio then uGTer_ArranqueParada.AlInicio else uGTer_ArranqueParada.AlFinal;

  {$IFDEF COMBUSTIBLES}
  if flg_Inicio then uGTer_OnOffPorPosteV2.AlInicio else uGTer_OnOffPorPosteV2.AlFinal;
  if flg_Inicio then ugter_onoffporpasoV2.AlInicio else ugter_onoffporpasoV2.AlFinal;
  if flg_Inicio then ugter_arranqueparadaV2.AlInicio else ugter_arranqueparadaV2.AlFinal;
  if flg_Inicio then ugter_combinadoV2.AlInicio else ugter_combinadoV2.AlFinal;
  {$ENDIF}

  {$ENDIF}

  if flg_Inicio then ucombustible.AlInicio else ucombustible.AlFinal;
  if flg_Inicio then uActorNodalCombustible.AlInicio else uActorNodalCombustible.AlFinal;
  if flg_Inicio then uArcoCombustible.AlInicio else uArcoCombustible.AlFinal;
  if flg_Inicio then unodocombustible.AlInicio else unodocombustible.AlFinal;
  if flg_Inicio then uDemandaCombustibleAnioBaseEIndices.AlInicio else uDemandaCombustibleAnioBaseEIndices.AlFinal;
  if flg_Inicio then uTSumComb.AlInicio else uTSumComb.AlFinal;
  if flg_Inicio then ugsimple_bicombustible.AlInicio else ugsimple_bicombustible.AlFinal;
  if flg_Inicio then ugsimple_MonoCombustible.AlInicio else ugsimple_MonoCombustible.AlFinal;
  if flg_Inicio then uRegasificadora.AlInicio else uRegasificadora.AlFinal;
  if flg_Inicio then uAgendaGNL.AlInicio else uAgendaGNL.AlFinal;


  if flg_Inicio then uParqueEolico.AlInicio else uParqueEolico.AlFinal;
  if flg_Inicio then uParqueEolico_vxy.AlInicio else uParqueEolico_vxy.AlFinal;
  if flg_Inicio then usolarPV.AlInicio else usolarPV.AlFinal;
  if flg_Inicio then usolartermico.AlInicio else usolartermico.AlFinal;
  if flg_Inicio then ubiomasaembalsable.AlInicio else ubiomasaembalsable.AlFinal;

  if flg_Inicio then uHidroConEmbalse.AlInicio else uHidroConEmbalse.AlFinal;
  if flg_Inicio then uHidroConBombeo.AlInicio else uHidroConBombeo.AlFinal;
  if flg_Inicio then uHidroConEmbalseBinacional.AlInicio else uHidroConEmbalseBinacional.AlFinal;
  if flg_Inicio then uHidroDePasada.AlInicio else uHidroDePasada.AlFinal;

  if flg_Inicio then uMercadoSpot.AlInicio else uMercadoSpot.AlFinal;
  if flg_Inicio then uMercadoSpot_postizado.AlInicio else uMercadoSpot_postizado.AlFinal;
  if flg_Inicio then uMercadoSpotConDetalleHorarioSemanal.AlInicio else uMercadoSpotConDetalleHorarioSemanal.AlFinal;
  if flg_Inicio then ucontratomodalidaddevolucion.AlInicio else ucontratomodalidaddevolucion.AlFinal;


  if flg_Inicio then ubancodebaterias01.AlInicio else ubancodebaterias01.AlFinal;
  if flg_Inicio then uUsoGestionable_postizado.AlInicio else uUsoGestionable_postizado.AlFinal;

{$IFDEF REGAS_UTE}
  if flg_Inicio then uSuministroCombustible.AlInicio else uSuministroCombustible.AlFinal;
  if flg_Inicio then uGNLSumIntermedio.AlInicio else uGNLSumIntermedio.AlFinal;
  if flg_Inicio then uGNLSuministroMultiCLiente.AlInicio else uGNLSuministroMultiCLiente.AlFinal;
  if flg_Inicio then uGNLSuministroCombustibleSimple.AlInicio else uGNLSuministroCombustibleSimple.AlFinal;
  if flg_Inicio then uGNLSumConector.AlInicio else uGNLSumConector.AlFinal;
  if flg_Inicio then uGNLSUmCOmb_TakeOrPay_Spot.AlInicio else uGNLSUmCOmb_TakeOrPay_Spot.AlFinal;
  if flg_Inicio then UGNLProveedor.AlInicio else UGNLProveedor.AlFinal;
  if flg_Inicio then uGNLPlanta.AlInicio else uGNLPlanta.AlFinal;
  if flg_Inicio then uGNLListaContratoSuministro.AlInicio else uGNLListaContratoSuministro.AlFinal;
  if flg_Inicio then uGNLGasoducto.AlInicio else uGNLGasoducto.AlFinal;
  if flg_Inicio then uGNLContratoSuministro.AlInicio else uGNLContratoSuministro.AlFinal;
  if flg_Inicio then uSuministroCombustible_TakeOrPay.AlInicio else uSuministroCombustible_TakeOrPay.AlFinal;
  if flg_Inicio then ugter_ConectableASuministro.AlInicio else ugter_ConectableASuministro.AlFinal;
{$ENDIF}

  // Fuentes =============================================
  if flg_Inicio then uFuentesAleatorias.AlInicio else uFuentesAleatorias.AlFinal;
  if flg_Inicio then uFuenteWeibull.AlInicio else uFuenteWeibull.AlFinal;
  if flg_Inicio then uFuenteGaussiana.AlInicio else uFuenteGaussiana.AlFinal;
  if flg_Inicio then uFuenteConstante.AlInicio else uFuenteConstante.AlFinal;
  if flg_Inicio then uFuenteUniforme.AlInicio else uFuenteUniforme.AlFinal;
  if flg_Inicio then uFuenteSintetizador.AlInicio else uFuenteSintetizador.AlFinal;
  if flg_Inicio then uFuenteCombinacion.AlInicio else uFuenteCombinacion.AlFinal;
  if flg_Inicio then uFuenteProducto.AlInicio else uFuenteProducto.AlFinal;
  if flg_Inicio then uFuenteSelector.AlInicio else uFuenteSelector.AlFinal;
  if flg_Inicio then ufuentetiempo.AlInicio else ufuentetiempo.AlFinal;
  if flg_Inicio then ufuentesinusoide.AlInicio else ufuentesinusoide.AlFinal;
  if flg_Inicio then ufuentemaxmin.AlInicio else ufuentemaxmin.AlFinal;
  if flg_Inicio then ufuenteselector_horario.AlInicio else ufuenteselector_horario.AlFinal;


  if flg_Inicio then uFichasLPD.AlInicio else uFichasLPD.AlFinal;
  if flg_Inicio then uEstados.AlInicio else uEstados.AlFinal;
  if flg_Inicio then upronostico.AlInicio else upronostico.AlFinal;
  if flg_Inicio then ufichasdeterminismos_obsoleta.AlInicio else ufichasdeterminismos_obsoleta.AlFinal;
  if flg_Inicio then ulistaplantillassr3.AlInicio else ulistaplantillassr3.AlFinal;
  if flg_Inicio then uescenarios.AlInicio else uescenarios.AlFinal;

{$IFDEF MISION_IMPOSIBLE}
  if flg_Inicio then uVirtualTablesDefs.AlInicio;
  if flg_Inicio then uRegistroDeEditores.AlInicio else uRegistroDeEditores.AlFinal;
{$ENDIF}

end;

procedure AlInicio;
begin
  Inc(cnt_llamadas);
  if (cnt_llamadas > 1) then
    exit;
  Call_Inicio_o_Final( true );
end;

procedure AlFinal;
begin
  Dec(cnt_llamadas);
  if (cnt_llamadas <> 0) then exit;
  Call_Inicio_o_Final( false );
end;

begin
  cnt_llamadas := 0;
end.
